local mapMod = foundation.createMod();

mapMod:registerAssetId("maps/MapHeightFjord.png", "HEIGHT_MAP")
mapMod:registerAssetId("maps/material_mask_c.png", "MATERIAL_MASK")
mapMod:registerAssetId("maps/coniferous_density.png", "CONIFEROUS_DENSITY_MAP")
mapMod:registerAssetId("maps/deciduous_density.png", "DECIDUOUS_DENSITY_MAP")
mapMod:registerAssetId("maps/berries_density.png", "BERRIES_DENSITY_MAP")
mapMod:registerAssetId("maps/rock_density.png", "ROCK_DENSITY_MAP")
mapMod:registerAssetId("maps/fish_density.png", "FISH_DENSITY_MAP")

-- Register Custom Map
mapMod:register({
	DataType = "CUSTOM_MAP",
	Id = "MAP_Fjord_2020",
	HeightMap = "HEIGHT_MAP",
	MaterialMask = "MATERIAL_MASK",
	MinHeight = -15,
	MaxHeight = 72,
	VillagePathList = {
		{
			Entrance = { 25, 0, 691 },
			Exit = { 25, 0, 691 }
		},
		{
			Entrance = { 25, 0, 622 },
			Exit = { 25, 0, 622 }
		},
		{
			Entrance = { 405, 0, 1000 },
			Exit = { 405, 0, 1000 }
		},
		{
			Entrance = { 335, 0, 1005 },
			Exit = { 335, 0, 1005 }
		}
	},
	SpawnList = {
		-- Hill 290, 400
		{
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 284, 27, 387 },
			Orientation = { 0.0, 270.0, 0.0 }
		},
		{
			Prefab = "PREFAB_MINERAL_SOURCE_2",
			Position = { 284, 25, 413 },
			Orientation = { 0.0, 290.0, 0.0 }
		},
		{
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 299, 22, 442 },
			Orientation = { 0.0, 0.0, 0.0 }
		},

		-- Hill 600, 850
		{
			Prefab = "PREFAB_MINERAL_SOURCE_3",
			Position = { 601, 14, 851 },
			Orientation = { 0.0, 180.0, 0.0 }
		},
		{
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 567, 12, 845 },
			Orientation = { 0.0, 180.0, 0.0 }
		},
		{
			Prefab = "PREFAB_MINERAL_SOURCE_2",
			Position = { 594, 22, 905 },
			Orientation = { 0.0, 180.0, 0.0 }
		},
		{
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 626, 23, 902 },
			Orientation = { 0.0, 180.0, 0.0 }
		},
		{
			Prefab = "PREFAB_MINERAL_SOURCE_3",
			Position = { 518, 24, 888 },
			Orientation = { 0.0, 190.0, 0.0 }
		},
		
		{
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 726, 12, 785 },
			Orientation = { 0.0, 270.0, 0.0 }
		},
		{
			Prefab = "PREFAB_MINERAL_SOURCE_2",
			Position = { 900, 36, 662 },
			Orientation = { 0.0, 270.0, 0.0 }
		},
		{
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 913, 37, 533 },
			Orientation = { 0.0, 320.0, 0.0 }
		},
		
		-- Hill 270, 220
		{
			Prefab = "PREFAB_MINERAL_SOURCE_2",
			Position = { 274, 48, 223 },
			Orientation = { 0.0, 10.0, 0.0 }
		},
		{
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 302, 49, 215 },
			Orientation = { 0.0, 0.0, 0.0 }
		},


		-- Hill 130, 770
		{
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 129, 22, 770 },
			Orientation = { 0.0, 110.0, 0.0 }
		},
		{
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 79, 36, 741 },
			Orientation = { 0.0, 100.0, 0.0 }
		},
		
	},
	DensitySpawnList = {
		{
			-- Create forest of Deciduous trees and a few pine
			DensityMap = "DECIDUOUS_DENSITY_MAP",
			Density = 0.90,
			PrefabConfigList = {
				{
					PrefabList = { "PREFAB_TREE_POPLAR" },
					RandomWeight = 8,
					OffsetSizeRange = {
						Min = 0.75,
						Max = 1
					},
					OrientationRange = {
						Min = { 0, -180, 0},
						Max = { 0, 180, 0}
					},
					ScaleRange = {
						Min = 0.85,
						Max = 1.15
					},
					ColorRange = {
						Min = { 0.8, 0.8, 0.8, 1 },
						Max = { 1, 1, 1, 1 }
					}
				},
				{
					PrefabList = { "PREFAB_TREE_OAK" },
					RandomWeight = 0.1,
					OffsetSizeRange = {
						Min = 0.9,
						Max = 1.9
					},
					OrientationRange = {
						Min = { 0, -180, 0},
						Max = { 0, 180, 0}
					},
					ScaleRange = {
						Min = 0.9,
						Max = 1.9
					},
					ColorRange = {
						Min = { 0.8, 0.8, 0.8, 1 },
						Max = { 1, 1, 1, 1 }
					}
				},
				{
					PrefabList = { "PREFAB_TREE_SYCAMORE" },
					RandomWeight = 8,
					OffsetSizeRange = {
						Min = 0.75,
						Max = 1
					},
					OrientationRange = {
						Min = { 0, -180, 0},
						Max = { 0, 180, 0}
					},
					ScaleRange = {
						Min = 0.85,
						Max = 1.15
					},
					ColorRange = {
						Min = { 0.8, 0.8, 0.8, 1 },
						Max = { 1, 1, 1, 1 }
					}
				},
				{
					PrefabList = { "PREFAB_TREE_PINE" },
					RandomWeight = 1,
					OffsetSizeRange = {
						Min = 0.15,
						Max = 0.45
					},
					OrientationRange = {
						Min = { 0, -180, 0},
						Max = { 0, 180, 0}
					},
					ScaleRange = {
						Min = 0.7,
						Max = 1
					},
					ColorRange = {
						Min = { 0.8, 0.8, 0.8, 1 },
						Max = { 1, 1, 1, 1 }
					}
				}
			}
		},
			{
			-- Create forest of Pine Trees
			DensityMap = "CONIFEROUS_DENSITY_MAP",
			Density = 0.88,
			PrefabConfigList = {
				{
					PrefabList = { "PREFAB_TREE_PINE" },
					RandomWeight = 0.1,
					OffsetSizeRange = {
						Min = 0.75,
						Max = 1
					},
					OrientationRange = {
						Min = { 0, -180, 0},
						Max = { 0, 180, 0}
					},
					ScaleRange = {
						Min = 0.85,
						Max = 1.15
					},
					ColorRange = {
						Min = { 0.8, 0.8, 0.8, 1 },
						Max = { 1, 1, 1, 1 }
					}
				}
			}
		},
		{
			-- Create forest of berry bushes
			DensityMap = "BERRIES_DENSITY_MAP",
			Density = 1,
			PrefabConfigList = {
				{
					PrefabList = { "PREFAB_RESOURCE_BERRIES" },
					RandomWeight = 0.1,
					OffsetSizeRange = {
						Min = 0.75,
						Max = 1
					},
					OrientationRange = {
						Min = { 0, -180, 0},
						Max = { 0, 180, 0}
					},
					ScaleRange = {
						Min = 0.85,
						Max = 1.15
					},
					ColorRange = {
						Min = { 0.8, 0.8, 0.8, 1 },
						Max = { 1, 1, 1, 1 }
					}
				}
			}
		},
		{
			-- Create rock outcrops - stone resource
			DensityMap = "ROCK_DENSITY_MAP",
			Density = 1,
			PrefabConfigList = {
				{
					PrefabList = { "PREFAB_RESOURCE_ROCK" },
					RandomWeight = 0.1,
					OffsetSizeRange = {
						Min = 0.75,
						Max = 1
					},
					OrientationRange = {
						Min = { 0, -180, 0},
						Max = { 0, 180, 0}
					},
					ScaleRange = {
						Min = 0.85,
						Max = 1.15
					},
					ColorRange = {
						Min = { 0.8, 0.8, 0.8, 1 },
						Max = { 1, 1, 1, 1 }
					}
				}
			}
		},
		{
			-- Create fish shoals
			DensityMap = "FISH_DENSITY_MAP",
			Density = 1,
			PrefabConfigList = {
				{
					PrefabList = { "PREFAB_RESOURCE_FISH" },
					RandomWeight = 0.1,
					OffsetSizeRange = {
						Min = 0.75,
						Max = 1
					},
					OrientationRange = {
						Min = { 0, -180, 0},
						Max = { 0, 180, 0}
					},
					ScaleRange = {
						Min = 0.85,
						Max = 1.15
					},
					ColorRange = {
						Min = { 0.8, 0.8, 0.8, 1 },
						Max = { 1, 1, 1, 1 }
					}
				}
			}
		}
	}
})